// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/14HSAI4/driver/14hsai4.h $
// $Rev: 53633 $
// $Date: 2023-08-29 09:41:27 -0500 (Tue, 29 Aug 2023) $

// 14HSAI4: Device Driver: header file

#ifndef	__14HSAI4_H__
#define	__14HSAI4_H__

#include "gsc_common.h"
#include "gsc_pci9056.h"



// macros *********************************************************************

#define	HSAI4_BASE_NAME						"14hsai4"

// IOCTL command codes
#define	HSAI4_IOCTL_REG_READ				OS_IOCTL_RW( 0, 12, gsc_reg_t)
#define	HSAI4_IOCTL_REG_WRITE				OS_IOCTL_W ( 1, 12, gsc_reg_t)
#define	HSAI4_IOCTL_REG_MOD					OS_IOCTL_W ( 2, 12, gsc_reg_t)
#define	HSAI4_IOCTL_QUERY					OS_IOCTL_RW( 3,  4, s32)
#define	HSAI4_IOCTL_INITIALIZE				OS_IOCTL   ( 4)
#define	HSAI4_IOCTL_AUTOCAL					OS_IOCTL   ( 5)
#define	HSAI4_IOCTL_AUTOCAL_STATUS			OS_IOCTL_R ( 6,  4, s32)
#define	HSAI4_IOCTL_RX_IO_MODE				OS_IOCTL_RW( 7,  4, s32)
#define	HSAI4_IOCTL_RX_IO_OVERFLOW			OS_IOCTL_RW( 8,  4, s32)
#define	HSAI4_IOCTL_RX_IO_TIMEOUT			OS_IOCTL_RW( 9,  4, s32)
#define	HSAI4_IOCTL_RX_IO_UNDERFLOW			OS_IOCTL_RW(10,  4, s32)
#define	HSAI4_IOCTL_AI_BUF_CLEAR			OS_IOCTL   (11)
#define	HSAI4_IOCTL_AI_BUF_ENABLE			OS_IOCTL_RW(12,  4, s32)
#define	HSAI4_IOCTL_AI_BUF_LEVEL			OS_IOCTL_R (13,  4, s32)
#define	HSAI4_IOCTL_AI_BUF_OVERFLOW			OS_IOCTL_RW(14,  4, s32)
#define	HSAI4_IOCTL_AI_BUF_THR_LVL			OS_IOCTL_RW(15,  4, s32)
#define	HSAI4_IOCTL_AI_BUF_THR_STS			OS_IOCTL_RW(16,  4, s32)
#define	HSAI4_IOCTL_AI_BUF_UNDERFLOW		OS_IOCTL_RW(17,  4, s32)
#define	HSAI4_IOCTL_AI_BURST_MARKER			OS_IOCTL_RW(18,  4, s32)
#define	HSAI4_IOCTL_AI_BURST_MODE			OS_IOCTL_RW(19,  4, s32)
#define	HSAI4_IOCTL_AI_BURST_SINGLE			OS_IOCTL_RW(20,  4, s32)
#define	HSAI4_IOCTL_AI_BURST_SIZE			OS_IOCTL_RW(21,  4, s32)
#define	HSAI4_IOCTL_AI_BURST_STATUS			OS_IOCTL_RW(22,  4, s32)
#define	HSAI4_IOCTL_AI_BURST_TRIGGER		OS_IOCTL   (23)
#define	HSAI4_IOCTL_AI_CHAN_SEL				OS_IOCTL_RW(24,  4, s32)
#define	HSAI4_IOCTL_AI_CHAN_TAG				OS_IOCTL_RW(25,  4, s32)
#define	HSAI4_IOCTL_AI_CLOCK_SRC			OS_IOCTL_RW(26,  4, s32)
#define	HSAI4_IOCTL_AI_CLOCKING				OS_IOCTL_RW(27,  4, s32)
#define	HSAI4_IOCTL_AI_DATA_PACKING			OS_IOCTL_RW(28,  4, s32)
#define	HSAI4_IOCTL_AI_MODE					OS_IOCTL_RW(29,  4, s32)
#define	HSAI4_IOCTL_AI_PRETRIG_MODE			OS_IOCTL_RW(30,  4, s32)
#define	HSAI4_IOCTL_AI_PRETRIG_SIZE			OS_IOCTL_RW(31,  4, s32)
#define	HSAI4_IOCTL_AI_PRETRIG_STS			OS_IOCTL_R (32,  4, s32)
#define	HSAI4_IOCTL_AI_RANGE				OS_IOCTL_RW(33,  4, s32)
#define	HSAI4_IOCTL_AI_SOL_CHAN				OS_IOCTL_RW(34,  4, s32)
#define	HSAI4_IOCTL_AI_SOL_HOLDOFF			OS_IOCTL_RW(35,  4, s32)
#define	HSAI4_IOCTL_AI_SOL_INT				OS_IOCTL_RW(36,  4, s32)
#define	HSAI4_IOCTL_AI_SOL_LEVEL			OS_IOCTL_RW(37,  4, s32)
#define	HSAI4_IOCTL_AI_SYNC_SRC				OS_IOCTL_RW(38,  4, s32)
#define	HSAI4_IOCTL_CBL_CLK_SYNC_DIR		OS_IOCTL_RW(39,  4, s32)
#define	HSAI4_IOCTL_DATA_FORMAT				OS_IOCTL_RW(40,  4, s32)
#define	HSAI4_IOCTL_GEN_INT_CLK_STATUS		OS_IOCTL_R (41,  4, s32)
#define	HSAI4_IOCTL_GEN_NDEC				OS_IOCTL_RW(42,  4, s32)
#define	HSAI4_IOCTL_GEN_NDIV_CLK			OS_IOCTL_RW(43,  4, s32)
#define	HSAI4_IOCTL_GEN_NDIV_SYNC			OS_IOCTL_RW(44,  4, s32)
#define	HSAI4_IOCTL_GEN_NREF				OS_IOCTL_RW(45,  4, s32)
#define	HSAI4_IOCTL_GEN_NVCO				OS_IOCTL_RW(46,  4, s32)
#define	HSAI4_IOCTL_IRQ_ENABLE				OS_IOCTL_RW(47,  4, s32)
#define	HSAI4_IOCTL_XCVR					OS_IOCTL_RW(48,  4, s32)
#define	HSAI4_IOCTL_RX_IO_ABORT				OS_IOCTL_R (49,  4, s32)
#define	HSAI4_IOCTL_WAIT_EVENT				OS_IOCTL_RW(50, 28, gsc_wait_t)
#define	HSAI4_IOCTL_WAIT_CANCEL				OS_IOCTL_RW(51, 28, gsc_wait_t)
#define	HSAI4_IOCTL_WAIT_STATUS				OS_IOCTL_RW(52, 28, gsc_wait_t)

//*****************************************************************************
// HSAI4_IOCTL_REG_READ
// HSAI4_IOCTL_REG_WRITE
// HSAI4_IOCTL_REG_MOD
//
#define	HSAI4_REG_ENCODE(s,o)				GSC_REG_ENCODE(GSC_REG_TYPE_BAR2,(s),(o))
// Parameter:	gsc_reg_t*
#define	HSAI4_GSC_BCTLR						HSAI4_REG_ENCODE(4,0x00)// Board Control Register
#define	HSAI4_GSC_PSTSR						HSAI4_REG_ENCODE(4,0x04)// Primary Status Register
#define	HSAI4_GSC_IDBR						HSAI4_REG_ENCODE(4,0x08)// Input Data Buffer Register
#define	HSAI4_GSC_IBCR						HSAI4_REG_ENCODE(4,0x0C)// Input Buffer Control Register
#define	HSAI4_GSC_BUFSR						HSAI4_REG_ENCODE(4,0x10)// Buffer Size Register
#define	HSAI4_GSC_RGAR						HSAI4_REG_ENCODE(4,0x14)// Rate Generator Adjust Register
#define	HSAI4_GSC_RDR						HSAI4_REG_ENCODE(4,0x18)// Rate Divisors Register
#define	HSAI4_GSC_DFR						HSAI4_REG_ENCODE(4,0x1C)// Decimation Factor Register
#define	HSAI4_GSC_CSCR						HSAI4_REG_ENCODE(4,0x20)// Clocking and Sync Control Register
#define	HSAI4_GSC_BSIZR						HSAI4_REG_ENCODE(4,0x24)// Burst Size Register
#define	HSAI4_GSC_PSIZR						HSAI4_REG_ENCODE(4,0x28)// Pretrigger Size Register
#define	HSAI4_GSC_TUR						HSAI4_REG_ENCODE(4,0x2C)// Test Utility Register
#define	HSAI4_GSC_BCFGR						HSAI4_REG_ENCODE(4,0x30)// Board Configuration Register
#define	HSAI4_GSC_AVR						HSAI4_REG_ENCODE(4,0x34)// Auto Cal Values Register

//*****************************************************************************
// HSAI4_IOCTL_QUERY
//
//	Parameter:	s32
//		Pass in a value from the list below.
//		The value returned is the answer to the query.

typedef enum
{
	HSAI4_QUERY_AI_RANGE_MAX,				// The maximum input voltage range.
	HSAI4_QUERY_AI_RANGE_MIN,				// The minimum input voltage range.
	HSAI4_QUERY_AUTOCAL,					// Is Autocal supported on this device?
	HSAI4_QUERY_AUTOCAL_MS,					// Max autocalibrate period in ms.
	HSAI4_QUERY_CHANNEL_AI_MAX,				// Maximum number of input channels supported.
	HSAI4_QUERY_CHANNEL_AI_QTY,				// The number of input channels supported.
	HSAI4_QUERY_COUNT,						// How many query options are supported?
	HSAI4_QUERY_DEVICE_TYPE,				// Value from gsc_dev_type_t
	HSAI4_QUERY_FGEN_MAX,					// Rate Generator maximum output rate.
	HSAI4_QUERY_FGEN_MIN,					// Rate Generator minimum output rate.
	HSAI4_QUERY_FIFO_SIZE_RX,				// Rx FIFO depth in 32-bit samples
	HSAI4_QUERY_FREF_DEFAULT,				// Default reference clock frequency.
	HSAI4_QUERY_FSAMP_AGG,					// The maximum aggrigate Fsamp rate.
	HSAI4_QUERY_FSAMP_MAX,					// The maximum Fsamp per channel.
	HSAI4_QUERY_FSAMP_MIN,					// The minimum Fsamp per channel.
	HSAI4_QUERY_FSYNC_MAX,					// The maximum Fsync value.
	HSAI4_QUERY_FSYNC_MIN,					// The minimum Fsync value.
	HSAI4_QUERY_INIT_MS,					// Max initialize period in ms.
	HSAI4_QUERY_INPUT_CONFIG,				// Input configuration BCFGR D17-D18, see below
	HSAI4_QUERY_INPUT_IMPED,				// Input inpedence BCFGR D19, see below
	HSAI4_QUERY_NDEC_MAX,					// Maximum Ndec value.
	HSAI4_QUERY_NDEC_MIN,					// Maximum Ndec value.
	HSAI4_QUERY_NDIV_CLK_MAX,				// Maximum Ndiv-clk value.
	HSAI4_QUERY_NDIV_CLK_MIN,				// Maximum Ndiv-clk value.
	HSAI4_QUERY_NDIV_SYNC_MAX,				// Maximum Ndiv-sync value.
	HSAI4_QUERY_NDIV_SYNC_MIN,				// Maximum Ndiv-sync value.
	HSAI4_QUERY_NREF_MAX,					// Maximum Nref value.
	HSAI4_QUERY_NREF_MIN,					// Maximum Nref value.
	HSAI4_QUERY_NVCO_MAX,					// Maximum Nvco value.
	HSAI4_QUERY_NVCO_MIN,					// Maximum Nvco value.
	HSAI4_QUERY_RATE_GEN_MS,				// Max rate generator settling period.

	HSAI4_IOCTL_QUERY_LAST

} hsai4_query_t;

#define	HSAI4_IOCTL_QUERY_ERROR				(-1)

// HSAI4_QUERY_INPUT_CONFIG
#define	HSAI4_INPUT_CONFIG_HIGH_LEVEL		0	// High-Level inputs
#define	HSAI4_INPUT_CONFIG_WIDEBAND			1	// Wideband inputs
#define	HSAI4_INPUT_CONFIG_TRANSFORMER		2	// Transformer-couled inputs

// HSAI4_QUERY_INPUT_IMPED
#define	HSAI4_INPUT_IMPED_2M				0	// 2 Megohmes
#define	HSAI4_INPUT_IMPED_50				1	// 50 ohmes

// Retained for backwards compatibility only:
#define	HSAI4_QUERY_AUTO_CAL				HSAI4_QUERY_AUTOCAL
#define	HSAI4_QUERY_AUTO_CAL_MS				HSAI4_QUERY_AUTOCAL_MS

//*****************************************************************************
// HSAI4_IOCTL_INITIALIZE				`	BCTLR D15
//
//	Parameter:	None

//*****************************************************************************
// HSAI4_IOCTL_AUTOCAL						BCTLR D13
//
//	Parameter:	None

// Retained for backwards compatibility only:
#define	HSAI4_IOCTL_AUTO_CALIBRATE			HSAI4_IOCTL_AUTOCAL

//*****************************************************************************
// HSAI4_IOCTL_AUTOCAL_STATUS				BCTLR D14
//
//	Parameter:	s32*
//		One of the below values is returned.
#define	HSAI4_AUTOCAL_STATUS_ACTIVE			0	// Now perform an Autocal.
#define	HSAI4_AUTOCAL_STATUS_FAIL			1	// Autocalibration failed
#define	HSAI4_AUTOCAL_STATUS_PASS			2	// Autocalibration passed

// Retained for backwards compatibility only:
#define	HSAI4_IOCTL_AUTO_CAL_STS			HSAI4_IOCTL_AUTOCAL_STATUS
#define	HSAI4_AUTO_CAL_STS_ACTIVE			HSAI4_AUTOCAL_STATUS_ACTIVE
#define	HSAI4_AUTO_CAL_STS_FAIL				HSAI4_AUTOCAL_STATUS_FAIL
#define	HSAI4_AUTO_CAL_STS_PASS				HSAI4_AUTOCAL_STATUS_PASS

//*****************************************************************************
// HSAI4_IOCTL_RX_IO_MODE
//
//	Parameter:	s32*
//		Pass in any of the gsc_io_mode_t options, or
//		-1 to read the current setting.
#define	HSAI4_IO_MODE_DEFAULT				GSC_IO_MODE_PIO

//*****************************************************************************
// HSAI4_IOCTL_RX_IO_OVERFLOW
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_IO_OVERFLOW_DEFAULT			HSAI4_IO_OVERFLOW_CHECK
#define	HSAI4_IO_OVERFLOW_IGNORE			0
#define	HSAI4_IO_OVERFLOW_CHECK				1

//*****************************************************************************
// HSAI4_IOCTL_RX_IO_TIMEOUT (in seconds)
//
//	Parameter:	s32*
//		Pass in any value from the minimim to the maximim, the infinite option,
//		or -1 to read the current setting. The value -1 is returned if the
//		feature is not supported, but this should never happen.
#define	HSAI4_IO_TIMEOUT_DEFAULT			10
#define	HSAI4_IO_TIMEOUT_NO_SLEEP			0
#define	HSAI4_IO_TIMEOUT_MIN				0
#define	HSAI4_IO_TIMEOUT_MAX				GSC_IO_TIMEOUT_MAX
#define	HSAI4_IO_TIMEOUT_INFINITE			GSC_IO_TIMEOUT_INFINITE

//*****************************************************************************
// HSAI4_IOCTL_RX_IO_UNDERFLOW
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_IO_UNDERFLOW_DEFAULT			HSAI4_IO_UNDERFLOW_CHECK
#define	HSAI4_IO_UNDERFLOW_IGNORE			0
#define	HSAI4_IO_UNDERFLOW_CHECK			1

//*****************************************************************************
// HSAI4_IOCTL_AI_BUF_CLEAR					IBCR D18
//
//	Parameter:	None.

//*****************************************************************************
// HSAI4_IOCTL_AI_BUF_ENABLE				IBCR D20
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	HSAI4_AI_BUF_ENABLE_NO				1	// Disable the buffer.
#define	HSAI4_AI_BUF_ENABLE_YES				0	// Enable the buffer.

//*****************************************************************************
// HSAI4_IOCTL_AI_BUF_LEVEL					BUFSR D0-D18
//
//	Parameter:	s32*
//		The value returned is the current buffer fill level.

//*****************************************************************************
// HSAI4_IOCTL_AI_BUF_OVERFLOW				BCTLR D17
// HSAI4_IOCTL_AI_BUF_UNDERFLOW				BCTLR D16
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	HSAI4_BUF_ERROR_CLEAR				0	// Clear the error.
#define	HSAI4_BUF_ERROR_IGNORE				(-1)

// For queries the following values are returned.
#define	HSAI4_BUF_ERROR_NO					0	// An error did NOT happen.
#define	HSAI4_BUF_ERROR_YES					1	// An error did happen..

//*****************************************************************************
// HSAI4_IOCTL_AI_BUF_THR_LVL				IBCR D0-D17
//
//	Parameter:	s32*
//		Pass in any value from 0x0 to 0x3FFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// HSAI4_IOCTL_AI_BUF_THR_STS				IBCR D19
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	HSAI4_AI_BUF_THR_STS_CLEAR			0
#define	HSAI4_AI_BUF_THR_STS_SET			1

//*****************************************************************************
// HSAI4_IOCTL_AI_BURST_MARKER				BCTLR D10
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_BURST_MARKER_DISABLE			0	// Disable Burst Marker
#define	HSAI4_BURST_MARKER_ENABLE			1	// Enable Burst Marker

//*****************************************************************************
// HSAI4_IOCTL_AI_BURST_MODE				BCTLR D9
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_BURST_MODE_DISABLE			0	// Disable Bursting
#define	HSAI4_BURST_MODE_ENABLE				1	// Enable Bursting

//*****************************************************************************
// HSAI4_IOCTL_AI_BURST_SINGLE				BCTLR D11
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_BURST_SINGLE_DISABLE			0	// Disable Single Burst Mode
#define	HSAI4_BURST_SINGLE_ENABLE			1	// Enable Single Burst Mode

//*****************************************************************************
// HSAI4_IOCTL_AI_BURST_SIZE				BSIZR D0-D19
//
//	Parameter:	s32*
//		Pass in any value from 0-0xFFFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// HSAI4_IOCTL_AI_BURST_STATUS				BCTLR D12
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	HSAI4_BURST_STATUS_IDLE				0	// Bursting is presently idle.
#define	HSAI4_BURST_STATUS_ACTIVE			1	// A burst is in progress.

//*****************************************************************************
// HSAI4_IOCTL_AI_BURST_TRIGGER				BCTLR D12
//
//	Parameter:	None

//*****************************************************************************
// HSAI4_IOCTL_AI_CHAN_SEL					CSCR D0-D3
//
//	Parameter:	s32*
//		Pass in a bitmap of the channels to enable, or
//		-1 to read the current setting.
//		A valid bitmap is 0x0 to 0x3 for two channel devices and 0x0 to 0xF for
//		four channel devices.

//*****************************************************************************
// HSAI4_IOCTL_AI_CHAN_TAG					IBCR D21
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_AI_CHAN_TAG_DISABLE			1	// Insert sign extension.
#define	HSAI4_AI_CHAN_TAG_ENABLE			0	// Insert the channel tag.

//*****************************************************************************
// HSAI4_IOCTL_AI_CLOCK_SRC					CSCR D4
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_AI_CLOCK_SRC_INTERNAL			0	// Use internal clocking.
#define	HSAI4_AI_CLOCK_SRC_EXTERNAL			1	// Use external clocking.

//*****************************************************************************
// HSAI4_IOCTL_AI_CLOCKING					BCTLR D8
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_AI_CLOCKING_DISABLE			0	// Disable Input Clocking
#define	HSAI4_AI_CLOCKING_ENABLE			1	// Enable Input Clocking

//*****************************************************************************
// HSAI4_IOCTL_AI_DATA_PACKING				BCTLR D18
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_AI_DATA_PACKING_DISABLE		0	// Disable data packing.
#define	HSAI4_AI_DATA_PACKING_ENABLE		1	// Enable data packing.

//*****************************************************************************
// HSAI4_IOCTL_AI_MODE						BCTLR D0-D2
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_AI_MODE_SYSTEM				0	// System Inputs
#define	HSAI4_AI_MODE_ZERO					2	// Zero test
#define	HSAI4_AI_MODE_VREF					3	// Vref test

//*****************************************************************************
// HSAI4_IOCTL_AI_PRETRIG_MODE				CSCR D12
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_AI_PRETRIG_MODE_DISABLE		0	// Disable Pretrigger mode.
#define	HSAI4_AI_PRETRIG_MODE_ENABLE		1	// Enable pretrigger mode.

//*****************************************************************************
// HSAI4_IOCTL_AI_PRETRIG_SIZE				PSIZR D0-D17
//
//	Parameter:	s32*
//		Pass in any value in the range of 0x2 to 0x3FFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// HSAI4_IOCTL_AI_PRETRIG_STS				CSCR D13
//
//	Parameter:	s32*
//		One of the below values is returned.
#define	HSAI4_AI_PRETRIG_STS_DONE			0	// Pretrigger data collected.
#define	HSAI4_AI_PRETRIG_STS_WAITING		1	// Waiting for trigger.

//*****************************************************************************
// HSAI4_IOCTL_AI_RANGE						BCTLR D4-D5
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_AI_RANGE_0_625V				0	// +- 0.625 Volts	Wideband
#define	HSAI4_AI_RANGE_1_25V				1	// +- 1.25 Volts	Wideband
#define	HSAI4_AI_RANGE_2_5V					2	// +- 2.5 Volts		Wideband, High-Level
#define	HSAI4_AI_RANGE_5V					3	// +- 5 Volts		High-Level
#define	HSAI4_AI_RANGE_10V					4	// +- 10 Volts		High-Level
#define	HSAI4_AI_RANGE_1_0VPP				5	// 1.0 Vp-p			Transformer
#define	HSAI4_AI_RANGE_2_0VPP				6	// 2.0 Vp-p			Transformer

//*****************************************************************************
// HSAI4_IOCTL_AI_SOL_CHAN					CSCR D6-D7
//
//	Parameter:	s32*
//		Pass in a valid channel index, or
//		-1 to read the current setting.
//		A valid channel index is 0 to 1 for two channel devices and 0 to 3 for
//		four channel devices.

//*****************************************************************************
// HSAI4_IOCTL_AI_SOL_HOLDOFF				CSCR D16-D17
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_AI_SOL_HOLDOFF_8				0	// 8 sample
#define	HSAI4_AI_SOL_HOLDOFF_64				1	// 64 sample
#define	HSAI4_AI_SOL_HOLDOFF_512			2	// 512 samples
#define	HSAI4_AI_SOL_HOLDOFF_INF			3	// infinite

//*****************************************************************************
// HSAI4_IOCTL_AI_SOL_INT					CSCR D14-D15
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_AI_SOL_INT_1					0	// SOL on 1 sample
#define	HSAI4_AI_SOL_INT_4					1	// SOL on 4 sample
#define	HSAI4_AI_SOL_INT_16					2	// SOL on 16 samples
#define	HSAI4_AI_SOL_INT_64					3	// SOL on 64 samples

//*****************************************************************************
// HSAI4_IOCTL_AI_SOL_LEVEL					CSCR D18-D31
//
//	Parameter:	s32*
//		Pass in any value from 0x0 to 0x3FFF, or
//		-1 to read the current setting.

//*****************************************************************************
// HSAI4_IOCTL_AI_SYNC_SRC					CSCR D8-D10
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_AI_SYNC_SRC_INTERNAL			0	// Use the internal source.
#define	HSAI4_AI_SYNC_SRC_EXTERNAL			1	// Use the external source.
#define	HSAI4_AI_SYNC_SRC_SOL_ABOVE			2	// Above Sync-On-Level.
#define	HSAI4_AI_SYNC_SRC_SOL_BELOW			3	// Below Sync-On-Level.
#define	HSAI4_AI_SYNC_SRC_BCR				4	// Manually via BCR D12

//*****************************************************************************
// HSAI4_IOCTL_CBL_CLK_SYNC_DIR				CSCR D11
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_CBL_CLK_SYNC_DIR_INPUT		0	// The signals are inputs.
#define	HSAI4_CBL_CLK_SYNC_DIR_OUTPUT		1	// The signals are outputs.

//*****************************************************************************
// HSAI4_IOCTL_DATA_FORMAT					BCTLR D6
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_DATA_FORMAT_2S_COMP			0	// Twos Compliment
#define	HSAI4_DATA_FORMAT_OFF_BIN			1	// Offset Binary

//*****************************************************************************
// HSAI4_IOCTL_GEN_INT_CLK_STATUS			CSCR D5
//
//	Parameter:	s32*
//		One of the below values is returned.
#define	HSAI4_GEN_INT_CLK_STATUS_READY		0	// Internal clock is ready.
#define	HSAI4_GEN_INT_CLK_STATUS_BUSY		1	// Internal clock is NOT ready.

//*****************************************************************************
// HSAI4_IOCTL_GEN_NDEC						DFR D0-D9
//
//	Parameter:	s32*
//		Pass in any value in the range of 1 to 1000, or
//		-1 to read the current setting.

//*****************************************************************************
// HSAI4_IOCTL_GEN_NDIV_CLK					RDR D24-D28
//
//	Parameter:	s32*
//		Pass in any value in the range of 1 to 25, or
//		-1 to read the current setting.

//*****************************************************************************
// HSAI4_IOCTL_GEN_NDIV_SYNC				RDR D0-D19
//
//	Parameter:	s32*
//		Pass in any value in the range of 10 to 0xFFFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// HSAI4_IOCTL_GEN_NREF						RGAR D16-D31
//
//	Parameter:	s32*
//		Pass in any value in the range of 20 to 1000, or
//		-1 to read the current setting.

//*****************************************************************************
// HSAI4_IOCTL_GEN_NVCO						RGAR D0-D15
//
//	Parameter:	s32*
//		Pass in any value in the range of 20 to 1000, or
//		-1 to read the current setting.

//*****************************************************************************
// HSAI4_IOCTL_IRQ_ENABLE					PSTSR 0x00003F3E
//
//	Parameter:	s32*
//		Pass in any combination of the below options, or
//		-1 to read the current setting.
#define	HSAI4_IRQ_AUTOCAL_ACTIVE			0x0002
#define	HSAI4_IRQ_AI_BURST_ACTIVE			0x0004
#define	HSAI4_IRQ_AI_BUF_THRESH				0x0008
#define	HSAI4_IRQ_AI_PRETRIG_ACTIVE			0x0010
#define	HSAI4_IRQ_AI_BUF_ERROR				0x0020
#define	HSAI4_IRQ_AUTOCAL_DONE				0x0100
#define	HSAI4_IRQ_AI_BURST_BEGIN			0x0200
#define	HSAI4_IRQ_AI_BURST_END				0x0400
#define	HSAI4_IRQ_AI_BUF_THRESH_L2H			0x0800
#define	HSAI4_IRQ_AI_BUF_THRESH_H2L			0x1000
#define	HSAI4_IRQ_AI_PRETRIG_ARM			0x2000
#define	HSAI4_IRQ_ALL						0x3F3E

// Retained for backwards compatibility only:
#define	HSAI4_IRQ_AUTO_CAL_ACTIVE			HSAI4_IRQ_AUTOCAL_ACTIVE
#define	HSAI4_IRQ_AUTO_CAL_DONE				HSAI4_IRQ_AUTOCAL_DONE

//*****************************************************************************
// HSAI4_IOCTL_XCVR							BCTLR D7
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSAI4_XCVR_TTL						0	// TTL
#define	HSAI4_XCVR_LVDS						1	// LVDS

//*****************************************************************************
// HSAI4_IOCTL_RX_IO_ABORT
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	HSAI4_IO_ABORT_NO					0
#define	HSAI4_IO_ABORT_YES					1

//*****************************************************************************
// HSAI4_IOCTL_WAIT_EVENT		all fields must be valid
// HSAI4_IOCTL_WAIT_CANCEL		fields need not be valid
// HSAI4_IOCTL_WAIT_STATUS		fields need not be valid
//
//	Parameter:	gsc_wait_t*
// gsc_wait_t.flags - see gsc_common.h
// gsc_wait_t.main - see gsc_common.h
// gsc_wait_t.gsc
#define	HSAI4_WAIT_GSC_AUTOCAL_ACTIVE		HSAI4_IRQ_AUTOCAL_ACTIVE
#define	HSAI4_WAIT_GSC_AI_BURST_ACTIVE		HSAI4_IRQ_AI_BURST_ACTIVE
#define	HSAI4_WAIT_GSC_AI_BUF_THRESH		HSAI4_IRQ_AI_BUF_THRESH
#define	HSAI4_WAIT_GSC_AI_PRETRIG_ACTIVE	HSAI4_IRQ_AI_PRETRIG_ACTIVE
#define	HSAI4_WAIT_GSC_AI_BUF_ERROR			HSAI4_IRQ_AI_BUF_ERROR
#define	HSAI4_WAIT_GSC_AUTOCAL_DONE			HSAI4_IRQ_AUTOCAL_DONE
#define	HSAI4_WAIT_GSC_AI_BURST_BEGIN		HSAI4_IRQ_AI_BURST_BEGIN
#define	HSAI4_WAIT_GSC_AI_BURST_END			HSAI4_IRQ_AI_BURST_END
#define	HSAI4_WAIT_GSC_AI_BUF_THRESH_L2H	HSAI4_IRQ_AI_BUF_THRESH_L2H
#define	HSAI4_WAIT_GSC_AI_BUF_THRESH_H2L	HSAI4_IRQ_AI_BUF_THRESH_H2L
#define	HSAI4_WAIT_GSC_AI_PRETRIG_ARM		HSAI4_IRQ_AI_PRETRIG_ARM
#define	HSAI4_WAIT_GSC_ALL					HSAI4_IRQ_ALL
// gsc_wait_t.alt flags
#define	HSAI4_WAIT_ALT_ALL					0x0000
// gsc_wait_t.io
#define	HSAI4_WAIT_IO_RX_ABORT				0x0001
#define	HSAI4_WAIT_IO_RX_DONE				0x0002
#define	HSAI4_WAIT_IO_RX_ERROR				0x0004
#define	HSAI4_WAIT_IO_RX_TIMEOUT			0x0008

#define	HSAI4_WAIT_IO_ALL					0x000F

// Retained for backwards compatibility only:
#define	HSAI4_WAIT_GSC_AUTO_CAL_ACTIVE		HSAI4_WAIT_GSC_AUTOCAL_ACTIVE
#define	HSAI4_WAIT_GSC_AUTO_CAL_DONE		HSAI4_WAIT_GSC_AUTOCAL_DONE



#endif
