// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/14HSAI4/include/14hsai4_utils.h $
// $Rev: 53630 $
// $Date: 2023-08-29 09:35:19 -0500 (Tue, 29 Aug 2023) $

// 14HSAI4: Utilities: header file

#ifndef	__14HSAI4_UTILS_H__
#define	__14HSAI4_UTILS_H__

#include "14hsai4_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	hsai4_close_util			(int fd, int index, int verbose);
int hsai4_init_util				(int verbose);
int hsai4_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	hsai4_open_util				(int device, int share, int index, int verbose, int* fd);
int	hsai4_read_util				(int fd, int index, int verbose, void* dst, size_t bytes, size_t* got);

// IOCTL utility services

int	hsai4_ai_buf_clear			(int fd, int index, int verbose);								// HSAI4_IOCTL_AI_BUF_CLEAR
int	hsai4_ai_buf_enable			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_BUF_ENABLE
int	hsai4_ai_buf_level			(int fd, int index, int verbose, s32* get);						// HSAI4_IOCTL_AI_BUF_LEVEL
int	hsai4_ai_buf_overflow		(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_BUF_OVERFLOW
int	hsai4_ai_buf_thr_lvl		(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_BUF_THR_LVL
int	hsai4_ai_buf_thr_sts		(int fd, int index, int verbose, s32* get);						// HSAI4_IOCTL_AI_BUF_THR_STS
int	hsai4_ai_buf_underflow		(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_BUF_UNDERFLOW
int	hsai4_ai_burst_marker		(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_BURST_MARKER
int	hsai4_ai_burst_mode			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_BURST_MODE
int	hsai4_ai_burst_single		(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_BURST_SINGLE
int	hsai4_ai_burst_size			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_BURST_SIZE
int	hsai4_ai_burst_status		(int fd, int index, int verbose, s32* get);						// HSAI4_IOCTL_AI_BURST_STATUS
int	hsai4_ai_burst_trigger		(int fd, int index, int verbose);								// HSAI4_IOCTL_AI_BURST_TRIGGER
int	hsai4_ai_chan_sel			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_CHAN_SEL
int	hsai4_ai_chan_tag			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_CHAN_TAG
int	hsai4_ai_clock_src			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_CLOCK_SRC
int	hsai4_ai_clocking			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_CLOCKING
int	hsai4_ai_data_packing		(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_DATA_PACKING
int	hsai4_ai_mode				(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_MODE
int	hsai4_ai_pretrig_mode		(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_PRETRIG_MODE
int	hsai4_ai_pretrig_size		(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_PRETRIG_SIZE
int	hsai4_ai_pretrig_sts		(int fd, int index, int verbose, s32* get);						// HSAI4_IOCTL_AI_PRETRIG_STS
int	hsai4_ai_range				(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_RANGE
int	hsai4_ai_sol_chan			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_SOL_CHAN
int	hsai4_ai_sol_holdoff		(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_SOL_HOLDOFF
int	hsai4_ai_sol_int			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_SOL_INT
int	hsai4_ai_sol_level			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_SOL_LEVEL
int	hsai4_ai_sync_src			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_AI_SYNC_SRC
int	hsai4_autocal				(int fd, int index, int verbose);								// HSAI4_IOCTL_AUTOCAL
int	hsai4_autocal_status		(int fd, int index, int verbose, s32* get);						// HSAI4_IOCTL_AUTOCAL_STATUS
int	hsai4_cbl_clk_sync_dir		(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_CBL_CLK_SYNC_DIR
int	hsai4_data_format			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_DATA_FORMAT
int	hsai4_gen_int_clk_status	(int fd, int index, int verbose, s32* get);						// HSAI4_IOCTL_GEN_INT_CLK_STATUS
int	hsai4_gen_ndec				(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_GEN_NDEC
int	hsai4_gen_ndiv_clk			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_GEN_NDIV_CLK
int	hsai4_gen_ndiv_sync			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_GEN_NDIV_SYNC
int	hsai4_gen_nref				(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_GEN_NREF
int	hsai4_gen_nvco				(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_GEN_NVCO
int	hsai4_initialize			(int fd, int index, int verbose);								// HSAI4_IOCTL_INITIALIZE
int	hsai4_irq_enable			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_IRQ_ENABLE
int	hsai4_query					(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_QUERY
int	hsai4_reg_mod				(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// HSAI4_IOCTL_REG_MOD
int	hsai4_reg_read				(int fd, int index, int verbose, u32 reg, u32* value);			// HSAI4_IOCTL_REG_READ
int	hsai4_reg_write				(int fd, int index, int verbose, u32 reg, u32 value);			// HSAI4_IOCTL_REG_WRITE
int	hsai4_rx_io_abort			(int fd, int index, int verbose, s32* get);						// HSAI4_IOCTL_RX_IO_ABORT
int	hsai4_rx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_RX_IO_MODE
int	hsai4_rx_io_overflow		(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_RX_IO_OVERFLOW
int	hsai4_rx_io_timeout			(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_RX_IO_TIMEOUT
int	hsai4_rx_io_underflow		(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_RX_IO_UNDERFLOW
int	hsai4_wait_cancel			(int fd, int index, int verbose, gsc_wait_t* wait);				// HSAI4_IOCTL_WAIT_CANCEL
int	hsai4_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// HSAI4_IOCTL_WAIT_EVENT
int	hsai4_wait_status			(int fd, int index, int verbose, gsc_wait_t* wait);				// HSAI4_IOCTL_WAIT_STATUS
int	hsai4_xcvr					(int fd, int index, int verbose, s32 set, s32* get);			// HSAI4_IOCTL_XCVR

// Auxiliary utility services

int	hsai4_config_ai				(int fd, int index, int verbose, s32 fsamp);
int	hsai4_fsamp_ai_compute		(int fd, int index, int verbose, s32 fsamp, s32* nvco, s32* nref, s32* ndiv_clk, s32* ndec, double* fsamp_got);
int	hsai4_fsamp_ai_get			(int fd, int index, int verbose, int title, s32* fsamp);
int hsai4_fsamp_ai_report		(int fd, int index, int verbose, int chan, s32* fsamp);
int hsai4_fsamp_ai_report_all	(int fd, int index, int verbose, s32* fsamp);
int	hsai4_fsync_ai_get			(int fd, int index, int verbose, s32* get);
int hsai4_id_device				(int fd, int index, int verbose);

int	hsai4_count_boards			(int verbose, s32* get);
int	hsai4_reg_list				(int fd, int detail);

const gsc_reg_def_t*			hsai4_reg_get_def_id			(u32 reg);
const gsc_reg_def_t*			hsai4_reg_get_def_index			(int index);
const char*						hsai4_reg_get_desc			(u32 reg);
const char*						hsai4_reg_get_name			(u32 reg);

// Retained for backwards compatibility only:
int	hsai4_auto_cal_sts			(int fd, int index, int verbose, s32* get);
int	hsai4_auto_calibrate		(int fd, int index, int verbose);


#endif
