// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/14HSAI4/samples/id/perform.c $
// $Rev: 53620 $
// $Date: 2023-08-29 09:23:32 -0500 (Tue, 29 Aug 2023) $

// 14HSAI4: Sample Application: source file

#include "main.h"




//*****************************************************************************
static void _sampling_modes(void)
{
	gsc_label("Input Sampling Modes");
	printf("Continuous, Burst, Pretriggering\n");
}



//*****************************************************************************
static void _clocking_sources(void)
{
	gsc_label("Clocking Sources");
	printf("Internal, External\n");
}



//*****************************************************************************
static void _syncing_sources(void)
{
	gsc_label("Syncing Sources");
	printf("Internal, External, Sync-On-Level, Software\n");
}



//*****************************************************************************
static int _id_device_reg(const args_t* args)
{
	int						errs;
	gsc_reg_def_t			list[2]	= { { NULL }, { NULL } };
	const gsc_reg_def_t*	ptr;

	printf("\n");
	ptr	= (gsc_reg_def_t*) hsai4_reg_get_def_id(HSAI4_GSC_BCFGR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, hsai4_reg_read);
	}
	else
	{
		errs	= 1;
		printf(	"FAIL <---  (%d. hsai4_reg_get_def_id, HSAI4_GSC_BCFGR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= hsai4_reg_list(args->fd, args->detail);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	_sampling_modes();
	_clocking_sources();
	_syncing_sources();

	for (i = 0; i < HSAI4_IOCTL_QUERY_LAST; i++)
		errs	+= hsai4_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_reg(args);
	errs	+= _register_map(args);
	printf("\n");

	return(errs);
}


