// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/14HSAI4/samples/sbtest/ai_range.c $
// $Rev: 51029 $
// $Date: 2022-04-27 11:39:59 -0500 (Wed, 27 Apr 2022) $

// 14HSAI4: Sample Application: source file

#include "main.h"




//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	high_level[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_RANGE,
			/* arg		*/	HSAI4_AI_RANGE_2_5V,
			/* reg		*/	HSAI4_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x00
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_RANGE,
			/* arg		*/	HSAI4_AI_RANGE_5V,
			/* reg		*/	HSAI4_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x10
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_RANGE,
			/* arg		*/	HSAI4_AI_RANGE_10V,
			/* reg		*/	HSAI4_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x20
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	transformer[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_RANGE,
			/* arg		*/	HSAI4_AI_RANGE_1_0VPP,
			/* reg		*/	HSAI4_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x00
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_RANGE,
			/* arg		*/	HSAI4_AI_RANGE_2_0VPP,
			/* reg		*/	HSAI4_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x10
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	wideband[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_RANGE,
			/* arg		*/	HSAI4_AI_RANGE_0_625V,
			/* reg		*/	HSAI4_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x00
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_RANGE,
			/* arg		*/	HSAI4_AI_RANGE_1_25V,
			/* reg		*/	HSAI4_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x10
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_RANGE,
			/* arg		*/	HSAI4_AI_RANGE_2_5V,
			/* reg		*/	HSAI4_GSC_BCTLR,
			/* mask		*/	0x30,
			/* value	*/	0x20
		},

		{ SERVICE_END_LIST }
	};

	s32						config	= 0;
	int						errs	= 0;
	const service_data_t*	ptr;

	errs	+= hsai4_query(fd, -1, 0, HSAI4_QUERY_INPUT_CONFIG, &config);

	switch (config)
	{
		default:
		case HSAI4_INPUT_CONFIG_HIGH_LEVEL:		ptr	= &high_level[0];	break;
		case HSAI4_INPUT_CONFIG_TRANSFORMER:	ptr	= &transformer[0];	break;
		case HSAI4_INPUT_CONFIG_WIDEBAND:		ptr	= &wideband[0];		break;
	}

	errs	+= hsai4_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, ptr);
	errs	+= service_ioctl_reg_get_list(fd, ptr);

	errs	+= service_ioctl_set_reg_list(fd, ptr);
	errs	+= service_ioctl_reg_get_list(fd, ptr);

	errs	+= hsai4_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// This requires additional equipment.
	return(0);
}



/******************************************************************************
*
*	Function:	ai_range_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HSAI4_IOCTL_AI_RANGE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai_range_test(int fd)
{
	int	errs	= 0;

	gsc_label("HSAI4_IOCTL_AI_RANGE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


