// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/14HSAI4/samples/sbtest/ai_sol_chan.c $
// $Rev: 51029 $
// $Date: 2022-04-27 11:39:59 -0500 (Wed, 27 Apr 2022) $

// 14HSAI4: Sample Application: source file

#include "main.h"




//*****************************************************************************
static int _service_test(int fd)
{
	service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_SOL_CHAN,
			/* arg		*/	0,
			/* reg		*/	HSAI4_GSC_CSCR,
			/* mask		*/	0xC0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	i;
	s32	max		= 0;
	s32	qty		= 0;
	s32	val;

	errs	+= hsai4_query(fd, -1, 0, HSAI4_QUERY_CHANNEL_AI_MAX, &max);
	errs	+= hsai4_query(fd, -1, 0, HSAI4_QUERY_CHANNEL_AI_QTY, &qty);

	for (i = -1; i <= max ; i++)
	{
		val				= i;
		val				= (val < 0) ? 0 : (val > (qty - 1)) ? (qty - 1) : val;
		list[0].arg		= val;
		list[0].value	= val << 6;

		errs	+= hsai4_initialize(fd, -1, 0);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= hsai4_initialize(fd, -1, 0);
	}

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// This requires additional equipment.
	return(0);
}



/******************************************************************************
*
*	Function:	ai_sol_chan_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HSAI4_IOCTL_AI_SOL_CHAN.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai_sol_chan_test(int fd)
{
	int	errs	= 0;

	gsc_label("HSAI4_IOCTL_AI_SOL_CHAN");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


