// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/14HSAI4/samples/sbtest/ai_sol_int.c $
// $Rev: 53626 $
// $Date: 2023-08-29 09:28:45 -0500 (Tue, 29 Aug 2023) $

// 14HSAI4: Sample Application: source file

#include "main.h"




//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_SOL_INT,
			/* arg		*/	HSAI4_AI_SOL_INT_1,
			/* reg		*/	HSAI4_GSC_CSCR,
			/* mask		*/	0xC000,
			/* value	*/	0x0000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_SOL_INT,
			/* arg		*/	HSAI4_AI_SOL_INT_4,
			/* reg		*/	HSAI4_GSC_CSCR,
			/* mask		*/	0xC000,
			/* value	*/	0x4000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_SOL_INT,
			/* arg		*/	HSAI4_AI_SOL_INT_16,
			/* reg		*/	HSAI4_GSC_CSCR,
			/* mask		*/	0xC000,
			/* value	*/	0x8000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_SOL_INT,
			/* arg		*/	HSAI4_AI_SOL_INT_64,
			/* reg		*/	HSAI4_GSC_CSCR,
			/* mask		*/	0xC000,
			/* value	*/	0xC000
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= hsai4_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_reg_get_list(fd, list);

	errs	+= hsai4_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _integrate_test(int fd, int integrate, int ms, int samples)
{
	service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_SOL_INT,
			/* arg		*/	integrate,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_SOL_HOLDOFF,
			/* arg		*/	HSAI4_AI_SOL_HOLDOFF_64,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_SOL_LEVEL,
			/* arg		*/	0x3000,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_BURST_MODE,
			/* arg		*/	HSAI4_BURST_MODE_ENABLE,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_CLOCKING,
			/* arg		*/	HSAI4_AI_CLOCKING_ENABLE,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_MODE,
			/* arg		*/	HSAI4_AI_MODE_ZERO,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_DATA_FORMAT,
			/* arg		*/	HSAI4_DATA_FORMAT_OFF_BIN,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_GEN_NVCO,
			/* arg		*/	50,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_GEN_NREF,
			/* arg		*/	60,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_GEN_NDIV_CLK,
			/* arg		*/	25,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_GEN_NDEC,
			/* arg		*/	1000,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_CHAN_SEL,
			/* arg		*/	0x1,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_BURST_SIZE,
			/* arg		*/	1,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_SYNC_SRC,
			/* arg		*/	HSAI4_AI_SYNC_SRC_SOL_ABOVE,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		// Initiate a trigger and check the results.

		{					// Initiate a sync trigger.
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AI_MODE,
			/* arg		*/	HSAI4_AI_MODE_VREF,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_SLEEP_MS,
			/* cmd		*/	0,
			/* arg		*/	ms,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	HSAI4_GSC_BUFSR,
			/* mask		*/	0x7FFFF,
			/* value	*/	samples
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;

	errs	+= hsai4_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, list);

	errs	+= hsai4_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	int	errs	= 0;

	// Holdoff period is 64 samples.

	// First integration period may be up to 4ms longer than programmed.
	// Subsequent integration periods may be up to 4ms longer than programmed.
	errs	+= _integrate_test(fd, HSAI4_AI_SOL_INT_1,	 10, 1);
	errs	+= _integrate_test(fd, HSAI4_AI_SOL_INT_1,	 60, 1);
	errs	+= _integrate_test(fd, HSAI4_AI_SOL_INT_1,	 77, 2);

	// First integration period may be up to 4ms longer than programmed.
	// Subsequent integration periods should be as programmed.
	errs	+= _integrate_test(fd, HSAI4_AI_SOL_INT_4,	 13, 1);
	errs	+= _integrate_test(fd, HSAI4_AI_SOL_INT_4,	 63, 1);
	errs	+= _integrate_test(fd, HSAI4_AI_SOL_INT_4,	 81, 2);

	// First integration period may be up to 4ms longer than programmed.
	// Subsequent integration periods should be as programmed.
	errs	+= _integrate_test(fd, HSAI4_AI_SOL_INT_16,	 25, 1);
	errs	+= _integrate_test(fd, HSAI4_AI_SOL_INT_16,	 75, 1);
	errs	+= _integrate_test(fd, HSAI4_AI_SOL_INT_16,	105, 2);

	// First integration period may be up to 4ms longer than programmed.
	// Subsequent integration periods should be as programmed.
	errs	+= _integrate_test(fd, HSAI4_AI_SOL_INT_64,	 73, 1);
	errs	+= _integrate_test(fd, HSAI4_AI_SOL_INT_64,	123, 1);
	errs	+= _integrate_test(fd, HSAI4_AI_SOL_INT_64,	201, 2);

	return(errs);
}



/******************************************************************************
*
*	Function:	ai_sol_int_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HSAI4_IOCTL_AI_SOL_INT.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai_sol_int_test(int fd)
{
	s32	config	= HSAI4_INPUT_CONFIG_HIGH_LEVEL;
	int	errs	= 0;

	gsc_label("HSAI4_IOCTL_AI_SOL_INT");
	errs	+= hsai4_query(fd, -1, 0, HSAI4_QUERY_INPUT_CONFIG, &config);

	if (config == HSAI4_INPUT_CONFIG_TRANSFORMER)
	{
		printf("SKIPPED  (Testing limitation for -TR devices.)\n");
	}
	else
	{
		errs	+= _service_test(fd);
		errs	+= _function_test(fd);

		if (errs == 0)
			printf("PASS\n");
	}

	return(errs);
}


