// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/14HSAI4/samples/sbtest/autocal_status.c $
// $Rev: 53626 $
// $Date: 2023-08-29 09:28:45 -0500 (Tue, 29 Aug 2023) $

// 14HSAI4: Sample Application: source file

#include "main.h"




//*****************************************************************************
static int _service_test(int fd)
{
	// There are no persistant bits to test.
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_AUTOCAL,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	ret;
	s32	sts		= 0;

	errs	+= hsai4_initialize(fd, -1, 0);

	ret		= hsai4_ioctl(fd, HSAI4_IOCTL_AUTOCAL_STATUS, &sts);
	errs	+= ret ? 1 : 0;

	if ((errs == 0) && (sts != HSAI4_AUTOCAL_STATUS_PASS))
	{
		errs++;
		printf("FAIL <---  (%d. status != PASS)\n", __LINE__);
	}

	errs	+= service_ioctl_set_reg_list(fd, list);

	ret		= hsai4_ioctl(fd, HSAI4_IOCTL_AUTOCAL_STATUS, &sts);
	errs	+= ret ? 1 : 0;

	if ((errs == 0) && (sts != HSAI4_AUTOCAL_STATUS_PASS))
	{
		errs++;
		printf("FAIL <---  (%d. status != PASS)\n", __LINE__);
	}

	errs	+= hsai4_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	autocal_status_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HSAI4_IOCTL_AUTOCAL_STATUS.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int autocal_status_test(int fd)
{
	s32	acal	= 0;
	int	errs	= 0;

	gsc_label("HSAI4_IOCTL_AUTOCAL_STATUS");
	errs	+= hsai4_query(fd, -1, 0, HSAI4_QUERY_AUTOCAL, &acal);

	if (acal)
	{
		errs	+= _service_test(fd);
		errs	+= _function_test(fd);

		if (errs == 0)
			printf("PASS\n");
	}
	else
	{
		printf("SKIPPED  (Autocalibration not supported on this device.)\n");
	}

	return(errs);
}


