// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/14HSAI4/samples/sbtest/gen_int_clk_status.c $
// $Rev: 51029 $
// $Date: 2022-04-27 11:39:59 -0500 (Wed, 27 Apr 2022) $

// 14HSAI4: Sample Application: source file

#include "main.h"




//*****************************************************************************
static int _service_test(int fd)
{
	// There are no persistent bits to test with this service.
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_REG_MOD,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	HSAI4_GSC_RGAR,
			/* mask		*/	0xFFFFFFFF,
			/* value	*/	0x003C0032
		},
		{
			/* service	*/	SERVICE_REG_MOD,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	HSAI4_GSC_RDR,
			/* mask		*/	0x1F000000,
			/* value	*/	0x01000000
		},
		{
			/* service	*/	SERVICE_SLEEP_MS,
			/* cmd		*/	0,
			/* arg		*/	100,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	ret;
	s32	sts;

	errs	+= hsai4_initialize(fd, -1, 0);

	// We don't test the BUSY state as there is noe guarantee as to how long
	// the device will be in the BUSY state.

	errs	+= service_ioctl_set_reg_list(fd, list);
	ret		= hsai4_ioctl(fd, HSAI4_IOCTL_GEN_INT_CLK_STATUS, &sts);
	errs	+= ret ? 1 : 0;

	if ((ret == 0) && (sts != HSAI4_GEN_INT_CLK_STATUS_READY))
	{
		errs++;
		printf(	"FAIL <---  (%d. got %ld, expected %ld)\n",
				__LINE__,
				(long) sts,
				(long) HSAI4_GEN_INT_CLK_STATUS_READY);
	}

	errs	+= hsai4_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	gen_int_clk_status_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HSAI4_IOCTL_GEN_INT_CLK_STATUS.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int gen_int_clk_status_test(int fd)
{
	int	errs	= 0;

	gsc_label("HSAI4_IOCTL_GEN_INT_CLK_STATUS");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


