// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/14HSAI4/samples/sbtest/gen_ndec.c $
// $Rev: 51029 $
// $Date: 2022-04-27 11:39:59 -0500 (Wed, 27 Apr 2022) $

// 14HSAI4: Sample Application: source file

#include "main.h"




//*****************************************************************************
static int _service_test(int fd)
{
	service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSAI4_IOCTL_GEN_NDEC,
			/* arg		*/	0,
			/* reg		*/	HSAI4_GSC_DFR,
			/* mask		*/	0x3FF,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	i;
	u32	val;

	for (i = 0; i <= 32; i++)
	{
		// Walking one.
		val				= (1L << i) & 0x3FF;
		val				= (val < 1) ? 1 : (val > 1000 ? 1000 : val);
		list[0].arg		= val;
		list[0].value	= val;

		errs	+= hsai4_initialize(fd, -1, 0);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= hsai4_initialize(fd, -1, 0);

		// Walking zero.
		val				= (0x3FF ^ (1 << i)) & 0x3FF;
		val				= (val < 1) ? 1 : (val > 1000 ? 1000 : val);
		list[0].arg		= val;
		list[0].value	= val;

		errs	+= hsai4_initialize(fd, -1, 0);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= hsai4_initialize(fd, -1, 0);
	}

	return(errs);

}



//*****************************************************************************
static int _function_test(int fd)
{
	// This requires additional equipment to verify.
	return(0);
}



/******************************************************************************
*
*	Function:	gen_ndec_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HSAI4_IOCTL_GEN_NDEC.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int gen_ndec_test(int fd)
{
	int	errs	= 0;

	gsc_label("HSAI4_IOCTL_GEN_NDEC");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


