// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/14HSAI4/samples/sbtest/perform.c $
// $Rev: 53626 $
// $Date: 2023-08-29 09:28:45 -0500 (Tue, 29 Aug 2023) $

// 14HSAI4: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;

	errs	+= reg_read_test(args->fd);			// HSAI4_IOCTL_REG_READ
	errs	+= reg_write_test(args->fd);			// HSAI4_IOCTL_REG_WRITE
	errs	+= reg_mod_test(args->fd);			// HSAI4_IOCTL_REG_MOD
	errs	+= query_test(args->fd);				// HSAI4_IOCTL_QUERY
	errs	+= initialize_test(args->fd);			// HSAI4_IOCTL_INITIALIZE
	errs	+= autocal_test(args->fd);			// HSAI4_IOCTL_AUTOCAL
	errs	+= autocal_status_test(args->fd);		// HSAI4_IOCTL_AUTOCAL_STATUS

	errs	+= rx_io_abort_test(args->fd);			// HSAI4_IOCTL_RX_IO_ABORT
	errs	+= rx_io_mode_test(args->fd);			// HSAI4_IOCTL_RX_IO_MODE
	errs	+= rx_io_overflow_test(args->fd);		// HSAI4_IOCTL_RX_IO_OVERFLOW
	errs	+= rx_io_timeout_test(args->fd);		// HSAI4_IOCTL_RX_IO_TIMEOUT
	errs	+= rx_io_underflow_test(args->fd);		// HSAI4_IOCTL_RX_IO_UNDERFLOW

	errs	+= ai_buf_clear_test(args->fd);			// HSAI4_IOCTL_AI_BUF_CLEAR
	errs	+= ai_buf_enable_test(args->fd);		// HSAI4_IOCTL_AI_BUF_ENABLE
	errs	+= ai_buf_level_test(args->fd);			// HSAI4_IOCTL_AI_BUF_LEVEL
	errs	+= ai_buf_overflow_test(args->fd);		// HSAI4_IOCTL_AI_BUF_OVERFLOW
	errs	+= ai_buf_thr_lvl_test(args->fd);		// HSAI4_IOCTL_AI_BUF_THR_LVL
	errs	+= ai_buf_thr_sts_test(args->fd);		// HSAI4_IOCTL_AI_BUF_THR_STS
	errs	+= ai_buf_underflow_test(args->fd);		// HSAI4_IOCTL_AI_BUF_UNDERFLOW
	errs	+= ai_burst_marker_test(args->fd);		// HSAI4_IOCTL_AI_BURST_MARKER
	errs	+= ai_burst_mode_test(args->fd);		// HSAI4_IOCTL_AI_BURST_MODE
	errs	+= ai_burst_single_test(args->fd);		// HSAI4_IOCTL_AI_BURST_SINGLE
	errs	+= ai_burst_size_test(args->fd);		// HSAI4_IOCTL_AI_BURST_SIZE
	errs	+= ai_burst_status_test(args->fd);		// HSAI4_IOCTL_AI_BURST_STATUS
	errs	+= ai_burst_trigger_test(args->fd);		// HSAI4_IOCTL_AI_BURST_TRIGGER
	errs	+= ai_chan_sel_test(args->fd);			// HSAI4_IOCTL_AI_CHAN_SEL
	errs	+= ai_chan_tag_test(args->fd);			// HSAI4_IOCTL_AI_CHAN_TAG
	errs	+= ai_clock_src_test(args->fd);			// HSAI4_IOCTL_AI_CLOCK_SRC
	errs	+= ai_clocking_test(args->fd);			// HSAI4_IOCTL_AI_CLOCKING
	errs	+= ai_data_packing_test(args->fd);		// HSAI4_IOCTL_AI_DATA_PACKING
	errs	+= ai_mode_test(args->fd);				// HSAI4_IOCTL_AI_MODE
	errs	+= ai_pretrig_mode_test(args->fd);		// HSAI4_IOCTL_AI_PRETRIG_MODE
	errs	+= ai_pretrig_size_test(args->fd);		// HSAI4_IOCTL_AI_PRETRIG_SIZE
	errs	+= ai_pretrig_sts_test(args->fd);		// HSAI4_IOCTL_AI_PRETRIG_STS
	errs	+= ai_range_test(args->fd);				// HSAI4_IOCTL_AI_RANGE
	errs	+= ai_sol_chan_test(args->fd);			// HSAI4_IOCTL_AI_SOL_CHAN
	errs	+= ai_sol_holdoff_test(args->fd);		// HSAI4_IOCTL_AI_SOL_HOLDOFF
	errs	+= ai_sol_int_test(args->fd);			// HSAI4_IOCTL_AI_SOL_INT
	errs	+= ai_sol_level_test(args->fd);			// HSAI4_IOCTL_AI_SOL_LEVEL
	errs	+= ai_sync_src_test(args->fd);			// HSAI4_IOCTL_AI_SYNC_SRC

	errs	+= cbl_clk_sync_dir_test(args->fd);		// HSAI4_IOCTL_CBL_CLK_SYNC_DIR
	errs	+= data_format_test(args->fd);			// HSAI4_IOCTL_DATA_FORMAT
	errs	+= gen_int_clk_status_test(args->fd);	// HSAI4_IOCTL_GEN_INT_CLK_STATUS
	errs	+= gen_ndec_test(args->fd);				// HSAI4_IOCTL_GEN_NDEC
	errs	+= gen_ndiv_clk_test(args->fd);			// HSAI4_IOCTL_GEN_NDIV_CLK
	errs	+= gen_ndiv_sync_test(args->fd);		// HSAI4_IOCTL_GEN_NDIV_SYNC
	errs	+= gen_nref_test(args->fd);				// HSAI4_IOCTL_GEN_NREF
	errs	+= gen_nvco_test(args->fd);				// HSAI4_IOCTL_GEN_NVCO
	errs	+= irq_enable_test(args->fd);			// HSAI4_IOCTL_IRQ_ENABLE
	errs	+= wait_event_test(args->fd);			// HSAI4_IOCTL_WAIT_EVENT
	errs	+= wait_cancel_test(args->fd);			// HSAI4_IOCTL_WAIT_CANCEL
	errs	+= wait_status_test(args->fd);			// HSAI4_IOCTL_WAIT_STATUS
	errs	+= xcvr_test(args->fd);					// HSAI4_IOCTL_XCVR

	return(errs);
}


