// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/14HSAI4/samples/sbtest/query.c $
// $Rev: 53626 $
// $Date: 2023-08-29 09:28:45 -0500 (Tue, 29 Aug 2023) $

// 14HSAI4: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	s32	data;
	s32	count;
	int	errs;
	int	i;

	errs	= hsai4_query(fd, -1, 0, HSAI4_QUERY_COUNT, &count);

	if (errs)
	{
		printf(	"FAIL <---  (count query failure)\n");
	}
	else if (count != (HSAI4_IOCTL_QUERY_LAST))
	{
		errs	= 1;
		printf(	"FAIL <---  (expected %ld, got %ld, rebuild application)\n",
				(long) HSAI4_IOCTL_QUERY_LAST,
				(long) count);
	}
	else
	{
		for (i = 0; (errs == 0) && (i < HSAI4_IOCTL_QUERY_LAST); i++)
		{
			errs	= hsai4_query(fd, -1, 0, i, &data);

			if (errs)
			{
				printf(	"FAIL <---  (query #%d failure)\n", i);
				break;
			}
		}
	}

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	return(0);
}



/******************************************************************************
*
*	Function:	query_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HSAI4_IOCTL_QUERY.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int query_test(int fd)
{
	int	errs	= 0;

	gsc_label("HSAI4_IOCTL_QUERY");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


