// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/14HSAI4/samples/signals/perform.c $
// $Rev: 53624 $
// $Date: 2023-08-29 09:26:56 -0500 (Tue, 29 Aug 2023) $

// 14HSAI4: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	char	buf[64];
	int		errs	= 0;

	//===============================================================
	gsc_label("Setup");
	printf("\n");
	gsc_label_level_inc();

	errs	+= hsai4_initialize			(args->fd, -1, 1);
	errs	+= hsai4_cbl_clk_sync_dir	(args->fd, -1, 1, HSAI4_CBL_CLK_SYNC_DIR_OUTPUT, NULL);
	errs	+= hsai4_xcvr				(args->fd, -1, 1, args->xcvr, NULL);

	gsc_label_level_dec();

	//===============================================================
	gsc_label("AI Clock");
	printf("\n");
	gsc_label_level_inc();

	errs	+= hsai4_ai_clock_src		(args->fd, -1, 1, HSAI4_AI_CLOCK_SRC_INTERNAL, NULL);
	errs	+= hsai4_gen_nvco			(args->fd, -1, 1, 80, NULL);
	errs	+= hsai4_gen_nref			(args->fd, -1, 1, 48, NULL);
	errs	+= hsai4_gen_ndiv_clk		(args->fd, -1, 1, 1, NULL);
	errs	+= hsai4_gen_ndec			(args->fd, -1, 1, 1, NULL);
	errs	+= hsai4_ai_chan_sel		(args->fd, -1, 1, 0x1, NULL);
	errs	+= hsai4_ai_clocking		(args->fd, -1, 1, HSAI4_AI_CLOCKING_ENABLE, NULL);
	errs	+= hsai4_fsamp_ai_report	(args->fd, -1, 1, 0, NULL);

	gsc_label_level_dec();

	//===============================================================
	gsc_label("AI Trigger");
	printf("\n");
	gsc_label_level_inc();

	errs	+= hsai4_ai_sync_src		(args->fd, -1, 1, HSAI4_AI_SYNC_SRC_INTERNAL, NULL);
	errs	+= hsai4_gen_ndiv_sync		(args->fd, -1, 1, 10, NULL);
	errs	+= hsai4_ai_burst_size		(args->fd, -1, 1, 1, NULL);
	errs	+= hsai4_ai_burst_mode		(args->fd, -1, 1, HSAI4_BURST_MODE_ENABLE, NULL);
	errs	+= hsai4_fsync_ai_get		(args->fd, -1, 1, NULL);

	gsc_label_level_dec();

	//===============================================================
	sprintf(buf, "Waiting (%ld sec%s)", (long) args->seconds, (args->seconds == 1) ? "" : "s");
	gsc_label(buf);
	fflush(stdout);
	os_sleep_ms(args->seconds * 1000);
	printf("Done\n");

	errs	+= hsai4_initialize			(args->fd, -1, 1);

	return(errs);
}



