// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/14HSAI4/utils/util_autocal.c $
// $Rev: 53627 $
// $Date: 2023-08-29 09:30:57 -0500 (Tue, 29 Aug 2023) $

// 14HSAI4: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	hsai4_autocal
*
*	Purpose:
*
*		Provide a visual wrapper for the HSAI4_IOCTL_AUTOCAL service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int hsai4_autocal(int fd, int index, int verbose)
{
	s32	acal	= 0;
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Autocalibrate", index);

	errs	= hsai4_query(fd, -1, 0, HSAI4_QUERY_AUTOCAL, &acal);

	if (acal)
	{
		ret		= hsai4_ioctl(fd, HSAI4_IOCTL_AUTOCAL, NULL);
		errs	= ret ? 1 : 0;

		if (verbose)
			printf("%s\n", errs ? "FAIL <---" : "PASS");
	}
	else
	{
		if (verbose)
			printf("SKIPPED  (Autocalibration not supported on this device.)\n");
	}

	return(errs);
}


