// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/14HSAI4/utils/util_gen_nref.c $
// $Rev: 53627 $
// $Date: 2023-08-29 09:30:57 -0500 (Tue, 29 Aug 2023) $

// 14HSAI4: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	hsai4_gen_nref
*
*	Purpose:
*
*		Provide a visual wrapper for the HSAI4_IOCTL_GEN_NREF service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int hsai4_gen_nref(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Rate Generator Nref", index);

	ret		= hsai4_ioctl(fd, HSAI4_IOCTL_GEN_NREF, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		printf(	"%s  (%ld (0x%lX))\n",
				errs ? "FAIL <---" : "PASS",
				(long) set,
				(long) set);
	}

	if (get)
		get[0]	= set;

	return(errs);
}


