// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/14HSAI4/utils/util_wait_cancel.c $
// $Rev: 51031 $
// $Date: 2022-04-27 11:42:21 -0500 (Wed, 27 Apr 2022) $

// 14HSAI4: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	hsai4_wait_cancel
*
*	Purpose:
*
*		Provide a visual wrapper for the HSAI4_IOCTL_WAIT_CANCEL service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		wait	This is the crieteria to use.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int hsai4_wait_cancel(int fd, int index, int verbose, gsc_wait_t* wait)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Wait Cancel", index);

	if (wait)
	{
		ret	= hsai4_ioctl(fd, HSAI4_IOCTL_WAIT_CANCEL, wait);

		if (verbose)
		{
			printf(	"%s  (%ld wait%s cancelled)\n",
					ret ? "FAIL <---" : "PASS",
					(long) wait->count,
					(wait->count == 1) ? "" : "s");
		}
	}
	else
	{
		ret		= 1;

		if (verbose)
			printf(	"FAIL <---  (NULL pointer)\n");
	}

	errs	= ret ? 1 : 0;
	return(errs);
}


